// generate steptone...

#include <stdio.h>
#include <process.h>
#include <conio.h>
#include <alloc.h>
#include <dos.h>
#include <time.h>
#include <mem.h>
#include <math.h>

#define PI 3.14159265

struct _waveheader {
	char 	riff[4];
	long 	block_size;
	char 	wave[4];
	char 	fmt[4];
	long 	chunk_size;
	int    	tag;
	int		channels;
	long	samples_per_sec;
	long	bytes_per_sec;
	int		block_align;
	int		bits_per_sample;
	char	data[4];
	long	data_size;
	};

_waveheader wh;              			// header for wave files
FILE * fo;						// file handles

int main (int argc, char * argv[])
{
long count;						// number of bytes in block
long q;
int r;
int s;
int t;

	if (argc < 2)
	{
		printf("Please specify output filename...\n");
		exit(1);
	}
	clrscr();
	printf("Opening %s for generation\n",argv[1]);

	// fill the header
	// total length will be 10 seconds

	memcpy (wh.riff,"RIFF",4);
	wh.block_size = 441036;
	memcpy (wh.wave,"WAVE",4);
	memcpy (wh.fmt,"fmt ",4);
	wh.chunk_size = 16;
	wh.tag = 1;
	wh.channels = 1;
	wh.samples_per_sec = 22050;
	wh.bytes_per_sec = 44100;
	wh.block_align = 2;
	wh.bits_per_sample= 16;
	memcpy(wh.data,"data",4);
	wh.data_size = 441000;

	fo = fopen(argv[1],"wb");			// write binary as output
	fwrite (&wh,sizeof(wh),1,fo);			// write the header

	for (t=1; t<41; t++)
	{
		for (count = 0; count < 4410; count++)
		{
			s = (int)(32767*sin((((float)(t*250+1000)/(float)22050)*count)*(2*PI)));
			fwrite (&s,sizeof(s),1,fo);
		}
		if ((t%4)==0)
			for (count = 0; count < 4410; count++)
			{
				s = 0;
				fwrite (&s,sizeof(s),1,fo);
			}
	}
	printf("All done!\n");

	fclose(fo);
}